// Generated by Apple Swift version 2.3 (swiftlang-800.10.12 clang-800.0.38)
#pragma clang diagnostic push

#if defined(__has_include) && __has_include(<swift/objc-prologue.h>)
# include <swift/objc-prologue.h>
#endif

#pragma clang diagnostic ignored "-Wauto-import"
#include <objc/NSObject.h>
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>

#if !defined(SWIFT_TYPEDEFS)
# define SWIFT_TYPEDEFS 1
# if defined(__has_include) && __has_include(<uchar.h>)
#  include <uchar.h>
# elif !defined(__cplusplus) || __cplusplus < 201103L
typedef uint_least16_t char16_t;
typedef uint_least32_t char32_t;
# endif
typedef float swift_float2  __attribute__((__ext_vector_type__(2)));
typedef float swift_float3  __attribute__((__ext_vector_type__(3)));
typedef float swift_float4  __attribute__((__ext_vector_type__(4)));
typedef double swift_double2  __attribute__((__ext_vector_type__(2)));
typedef double swift_double3  __attribute__((__ext_vector_type__(3)));
typedef double swift_double4  __attribute__((__ext_vector_type__(4)));
typedef int swift_int2  __attribute__((__ext_vector_type__(2)));
typedef int swift_int3  __attribute__((__ext_vector_type__(3)));
typedef int swift_int4  __attribute__((__ext_vector_type__(4)));
#endif

#if !defined(SWIFT_PASTE)
# define SWIFT_PASTE_HELPER(x, y) x##y
# define SWIFT_PASTE(x, y) SWIFT_PASTE_HELPER(x, y)
#endif
#if !defined(SWIFT_METATYPE)
# define SWIFT_METATYPE(X) Class
#endif

#if defined(__has_attribute) && __has_attribute(objc_runtime_name)
# define SWIFT_RUNTIME_NAME(X) __attribute__((objc_runtime_name(X)))
#else
# define SWIFT_RUNTIME_NAME(X)
#endif
#if defined(__has_attribute) && __has_attribute(swift_name)
# define SWIFT_COMPILE_NAME(X) __attribute__((swift_name(X)))
#else
# define SWIFT_COMPILE_NAME(X)
#endif
#if !defined(SWIFT_CLASS_EXTRA)
# define SWIFT_CLASS_EXTRA
#endif
#if !defined(SWIFT_PROTOCOL_EXTRA)
# define SWIFT_PROTOCOL_EXTRA
#endif
#if !defined(SWIFT_ENUM_EXTRA)
# define SWIFT_ENUM_EXTRA
#endif
#if !defined(SWIFT_CLASS)
# if defined(__has_attribute) && __has_attribute(objc_subclassing_restricted)
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# else
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# endif
#endif

#if !defined(SWIFT_PROTOCOL)
# define SWIFT_PROTOCOL(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
# define SWIFT_PROTOCOL_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
#endif

#if !defined(SWIFT_EXTENSION)
# define SWIFT_EXTENSION(M) SWIFT_PASTE(M##_Swift_, __LINE__)
#endif

#if !defined(OBJC_DESIGNATED_INITIALIZER)
# if defined(__has_attribute) && __has_attribute(objc_designated_initializer)
#  define OBJC_DESIGNATED_INITIALIZER __attribute__((objc_designated_initializer))
# else
#  define OBJC_DESIGNATED_INITIALIZER
# endif
#endif
#if !defined(SWIFT_ENUM)
# define SWIFT_ENUM(_type, _name) enum _name : _type _name; enum SWIFT_ENUM_EXTRA _name : _type
# if defined(__has_feature) && __has_feature(generalized_swift_name)
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME) enum _name : _type _name SWIFT_COMPILE_NAME(SWIFT_NAME); enum SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_ENUM_EXTRA _name : _type
# else
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME) SWIFT_ENUM(_type, _name)
# endif
#endif
#if defined(__has_feature) && __has_feature(modules)
@import ObjectiveC;
@import AmpCore;
#endif

#import <AmpNielsenDCR/AmpNielsenDCR.h>

#pragma clang diagnostic ignored "-Wproperty-attribute-mismatch"
#pragma clang diagnostic ignored "-Wduplicate-method-arg"
@class AmpPlayer;
@protocol AmpNielsenDCRObserver;
@class NielsenAppApi;


/// Class in charge of manage the Nielsen DCR integration.
SWIFT_CLASS("_TtC13AmpNielsenDCR20AmpNielsenDCRManager")
@interface AmpNielsenDCRManager : NSObject <PlayerEventObserver, NielsenAppApiDelegate>

/// The native player.
@property (nonatomic, readonly, strong) AmpPlayer * _Nullable ampPlayer;

/// Initializes a new AmpPlayer with the parameters provided.
///
/// \param player The player where the plugins is activated
///
/// \param appInfo Dictionary with the Nielsen init info: appid, appversion, appname, sfcode
- (nonnull instancetype)initWithPlayer:(AmpPlayer * _Nonnull)player appInfo:(NSDictionary<NSString *, id> * _Nonnull)appInfo OBJC_DESIGNATED_INITIALIZER;

/// Initializes a new AmpPlayer with the parameters provided. The configuration should loaded from a config file
///
/// \param player The player where the plugins is activated
- (nonnull instancetype)initWithPlayer:(AmpPlayer * _Nonnull)player OBJC_DESIGNATED_INITIALIZER;

/// Get the URL of the web page that is used for giving user a chance to opt out from the Nielsen measurements..
///
/// <ul><li>returns String</li></ul>
- (NSString * _Nonnull)getOptOutURL;
- (BOOL)userOptOut:(NSString * _Nonnull)optOut;

/// Registers an observer to be notified of plugin events.
///
/// \param observer The observer to be registered.
///
/// \returns  The id of the registered observer.
- (NSInteger)registerObserver:(id <AmpNielsenDCRObserver> _Nonnull)observer;

/// Set the player info
///
/// \param playerInfo Dictionary with the Nielsen Player Info: channelName, adModel, dataSrc.
- (void)setPlayerInfo:(NSDictionary<NSString *, id> * _Nonnull)playerInfo;

/// Load the Player Metadata
///
/// \param metadata Dictionary with the Nielsen Player Metadata: type, content, assetid, tv, program, title, category, length.
- (void)loadMetaData:(NSDictionary<NSString *, id> * _Nonnull)metaData;
- (void)observeValueForKeyPath:(NSString * _Nullable)keyPath ofObject:(id _Nullable)object change:(NSDictionary<NSString *, id> * _Nullable)change context:(void * _Null_unspecified)context;

/// :nodoc:
- (void)nielsenAppApi:(NielsenAppApi * _Nonnull)appApi eventOccurred:(NSDictionary * _Nonnull)eventOccurred;

/// :nodoc:
- (void)nielsenAppApi:(NielsenAppApi * _Nonnull)appApi errorOccurred:(NSDictionary * _Nonnull)errorOccurred;
- (void)onAmpTimeChange:(AmpPlayer * _Nonnull)ampPlayer;

/// :nodoc:
- (void)onPlaybackEnded:(AmpPlayer * _Nonnull)ampPlayer;

/// :nodoc:
- (void)onReplay:(AmpPlayer * _Nonnull)ampPlayer;

/// :nodoc:
- (void)onAmpPlaybackStateChanged:(AmpPlayer * _Nonnull)ampPlayer;

/// Releases all the references and variables
- (void)unload;
@end

@class NSArray;


/// Protocol used to receive Nielsen DCR Plugin events.
SWIFT_PROTOCOL("_TtP13AmpNielsenDCR21AmpNielsenDCRObserver_")
@protocol AmpNielsenDCRObserver

/// Callback called when Nielsen Api received a Event.
///
/// \param player The player where the plugins is activated
///
/// \param appId String with the Nielsen App Id
///
/// \param eventOccurred Dictionary with the event
- (void)eventOccurred:(AmpPlayer * _Nonnull)player appId:(NSString * _Nonnull)appId eventOccurred:(NSDictionary * _Nonnull)eventOccurred;

/// Callback called when Nielsen Api received a Error.
///
/// \param player The player where the plugins is activated
///
/// \param appId String with the Nielsen App Id
///
/// \param error Dictionary with the Error
- (void)errorOccurred:(AmpPlayer * _Nonnull)player appId:(NSString * _Nonnull)appId error:(NSDictionary * _Nonnull)error;

/// Callback called when Nielsen Api received metadata.
///
/// \param player The player where the plugins is activated
///
/// \param metaData Meta Data Array
- (void)onReceiveMetaData:(AmpPlayer * _Nonnull)player metaData:(NSArray * _Nonnull)metaData;
@end

#pragma clang diagnostic pop
